OpenShot Audio Library | OpenShotAudio: juce::AudioSubsectionReader Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.0

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::AudioSubsectionReader Class Reference

`#include <juce_AudioSubsectionReader.h>`

Inheritance diagram for juce::AudioSubsectionReader:

## Public Member Functions
| AudioSubsectionReader (AudioFormatReader *sourceReader, int64 subsectionStartSample, int64 subsectionLength, bool deleteSourceWhenDeleted)
| ~AudioSubsectionReader () override
bool | readSamples (int **destSamples, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int numSamples) override
void | readMaxLevels (int64 startSample, int64 numSamples, Range< float > *results, int numChannelsToRead) override
virtual void | readMaxLevels (int64 startSample, int64 numSamples, Range< float > *results, int numChannelsToRead)
virtual void | readMaxLevels (int64 startSample, int64 numSamples, float &lowestLeft, float &highestLeft, float &lowestRight, float &highestRight)
Public Member Functions inherited from juce::AudioFormatReader
virtual | ~AudioFormatReader ()
const String & | getFormatName () const noexcept
bool | read (float *const *destChannels, int numDestChannels, int64 startSampleInSource, int numSamplesToRead)
bool | read (int *const *destChannels, int numDestChannels, int64 startSampleInSource, int numSamplesToRead, bool fillLeftoverChannelsWithCopies)
void | read (AudioBuffer< float > *buffer, int startSampleInDestBuffer, int numSamples, int64 readerStartSample, bool useReaderLeftChan, bool useReaderRightChan)
virtual void | readMaxLevels (int64 startSample, int64 numSamples, Range< float > *results, int numChannelsToRead)
virtual void | readMaxLevels (int64 startSample, int64 numSamples, float &lowestLeft, float &highestLeft, float &lowestRight, float &highestRight)
int64 | searchForLevel (int64 startSample, int64 numSamplesToSearch, double magnitudeRangeMinimum, double magnitudeRangeMaximum, int minimumConsecutiveSamples)
virtual AudioChannelSet | getChannelLayout ()
virtual bool | readSamples (int **destChannels, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int numSamples)=0

## Additional Inherited Members
Public Attributes inherited from juce::AudioFormatReader
double | sampleRate = 0
unsigned int | bitsPerSample = 0
int64 | lengthInSamples = 0
unsigned int | numChannels = 0
bool | usesFloatingPointData = false
StringPairArray | metadataValues
InputStream * | input
Protected Member Functions inherited from juce::AudioFormatReader
| AudioFormatReader (InputStream *sourceStream, const String &formatName)
Static Protected Member Functions inherited from juce::AudioFormatReader
static void | clearSamplesBeyondAvailableLength (int **destChannels, int numDestChannels, int startOffsetInDestBuffer, int64 startSampleInFile, int &numSamples, int64 fileLengthInSamples)

## Detailed Description

This class is used to wrap an AudioFormatReader and only read from a subsection of the file.

So if you have a reader which can read a 1000 sample file, you could wrap it in one of these to only access, e.g. samples 100 to 200, and any samples outside that will come back as 0. Accessing sample 0 from this reader will actually read the first sample from the other's subsection, which might be at a non-zero position.

See also
  AudioFormatReader

Definition at line 45 of file juce_AudioSubsectionReader.h.

## Constructor & Destructor Documentation

## ◆ AudioSubsectionReader()

juce::AudioSubsectionReader::AudioSubsectionReader | ( | AudioFormatReader * | sourceReader,
|  | int64 | subsectionStartSample,
|  | int64 | subsectionLength,
|  | bool | deleteSourceWhenDeleted
| ) |  |

Creates an AudioSubsectionReader for a given data source.

Parameters

  sourceReader | the source reader from which we'll be taking data
  subsectionStartSample | the sample within the source reader which will be mapped onto sample 0 for this reader.
  subsectionLength | the number of samples from the source that will make up the subsection. If this reader is asked for any samples beyond this region, it will return zero.
  deleteSourceWhenDeleted | if true, the sourceReader object will be deleted when this object is deleted.

Definition at line 30 of file juce_AudioSubsectionReader.cpp.

## ◆ ~AudioSubsectionReader()

juce::AudioSubsectionReader::~AudioSubsectionReader | ( |  | ) |
| override

Destructor.

Definition at line 47 of file juce_AudioSubsectionReader.cpp.

## Member Function Documentation

## ◆ readMaxLevels() [1/3]

void juce::AudioFormatReader::readMaxLevels | ( | int64 | startSample,
|  | int64 | numSamples,
|  | float & | lowestLeft,
|  | float & | highestLeft,
|  | float & | lowestRight,
|  | float & | highestRight
| ) |  |
| virtual

Finds the highest and lowest sample levels from a section of the audio stream.

This will read a block of samples from the stream, and measure the highest and lowest sample levels from the channels in that section, returning these as normalised floating-point levels.

Parameters

  startSample | the offset into the audio stream to start reading from. It's ok for this to be beyond the start or end of the stream.
  numSamples | how many samples to read
  lowestLeft | on return, this is the lowest absolute sample from the left channel
  highestLeft | on return, this is the highest absolute sample from the left channel
  lowestRight | on return, this is the lowest absolute sample from the right channel (if there is one)
  highestRight | on return, this is the highest absolute sample from the right channel (if there is one)

See also
  read

Reimplemented from juce::AudioFormatReader.

Definition at line 187 of file juce_AudioFormatReader.cpp.

## ◆ readMaxLevels() [2/3]

void juce::AudioFormatReader::readMaxLevels | ( | int64 | startSample,
|  | int64 | numSamples,
|  | Range< float > * | results,
|  | int | numChannelsToRead
| ) |  |
| virtual

Finds the highest and lowest sample levels from a section of the audio stream.

This will read a block of samples from the stream, and measure the highest and lowest sample levels from the channels in that section, returning these as normalised floating-point levels.

Parameters

  startSample | the offset into the audio stream to start reading from. It's ok for this to be beyond the start or end of the stream.
  numSamples | how many samples to read
  results | this array will be filled with Range values for each channel. The array must contain numChannels elements.
  numChannelsToRead | the number of channels of data to scan. This must be more than zero, but not more than the total number of channels that the reader contains

See also
  read

Reimplemented from juce::AudioFormatReader.

Definition at line 167 of file juce_AudioFormatReader.cpp.

## ◆ readMaxLevels() [3/3]

void juce::AudioSubsectionReader::readMaxLevels | ( | int64 | startSample,
|  | int64 | numSamples,
|  | Range< float > * | results,
|  | int | numChannelsToRead
| ) |  |
| overridevirtual

Finds the highest and lowest sample levels from a section of the audio stream.

This will read a block of samples from the stream, and measure the highest and lowest sample levels from the channels in that section, returning these as normalised floating-point levels.

Parameters

  startSample | the offset into the audio stream to start reading from. It's ok for this to be beyond the start or end of the stream.
  numSamples | how many samples to read
  results | this array will be filled with Range values for each channel. The array must contain numChannels elements.
  numChannelsToRead | the number of channels of data to scan. This must be more than zero, but not more than the total number of channels that the reader contains

See also
  read

Reimplemented from juce::AudioFormatReader.

Definition at line 64 of file juce_AudioSubsectionReader.cpp.

## ◆ readSamples()

bool juce::AudioSubsectionReader::readSamples | ( | int ** | destChannels,
|  | int | numDestChannels,
|  | int | startOffsetInDestBuffer,
|  | int64 | startSampleInFile,
|  | int | numSamples
| ) |  |
| overridevirtual

Subclasses must implement this method to perform the low-level read operation.

Callers should use read() instead of calling this directly.

Parameters

  destChannels | the array of destination buffers to fill. Some of these pointers may be null
  numDestChannels | the number of items in the destChannels array. This value is guaranteed not to be greater than the number of channels that this reader object contains
  startOffsetInDestBuffer | the number of samples from the start of the dest data at which to begin writing
  startSampleInFile | the number of samples into the source data at which to begin reading. This value is guaranteed to be >= 0.
  numSamples | the number of samples to read

Implements juce::AudioFormatReader.

Definition at line 54 of file juce_AudioSubsectionReader.cpp.

The documentation for this class was generated from the following files:

- juce_AudioSubsectionReader.h
- juce_AudioSubsectionReader.cpp